package com.schisandra.oss.application.controller;

import com.alibaba.fastjson.JSON;
import com.google.common.base.Preconditions;
import com.schisandra.oss.application.convert.SchisandraOssPinganDTOConverter;
import com.schisandra.oss.application.dto.SchisandraOssPinganDTO;
import com.schisandra.oss.common.entity.Result;
import com.schisandra.oss.domain.bo.SchisandraOssPinganBO;
import com.schisandra.oss.domain.service.SchisandraOssPinganDomainService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * 平安云对象存储配置表 controller
 *
 * @author landaiqing
 * @since 2024-06-02 22:19:22
 */
@RestController
@RequestMapping("/oss/pingan/")
@Slf4j
public class SchisandraOssPinganController {

    @Resource
    private SchisandraOssPinganDomainService schisandraOssPinganDomainService;

    /**
     * 新增平安云对象存储配置表
     */
    @RequestMapping("add")
    public Result<Boolean> add(@RequestBody SchisandraOssPinganDTO schisandraOssPinganDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssPinganController.add.dto:{}", JSON.toJSONString(schisandraOssPinganDTO));
            }
            Preconditions.checkNotNull(schisandraOssPinganDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getSystemUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getUserAgent(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getObsUrl(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getObsAccessKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getObsSecret(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getBucketName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getRepresentPathInKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getDomainName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getExtraJson(), "额外字段不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getCreateBucket(), "当桶不存在，是否创建不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getCheckBucket(), "启动检测桶，是否存在不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            SchisandraOssPinganBO SchisandraOssPinganBO = SchisandraOssPinganDTOConverter.INSTANCE.convertDTOToBO(schisandraOssPinganDTO);
            return Result.ok(schisandraOssPinganDomainService.add(SchisandraOssPinganBO));
        } catch (Exception e) {
            log.error("SchisandraOssPinganController.register.error:{}", e.getMessage(), e);
            return Result.fail("新增平安云对象存储配置表失败");
        }

    }

    /**
     * 修改平安云对象存储配置表
     */
    @RequestMapping("update")
    public Result<Boolean> update(@RequestBody SchisandraOssPinganDTO schisandraOssPinganDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssPinganController.update.dto:{}", JSON.toJSONString(schisandraOssPinganDTO));
            }
            Preconditions.checkNotNull(schisandraOssPinganDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getSystemUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getUserAgent(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getObsUrl(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getObsAccessKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getObsSecret(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getBucketName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getRepresentPathInKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getDomainName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getExtraJson(), "额外字段不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getCreateBucket(), "当桶不存在，是否创建不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getCheckBucket(), "启动检测桶，是否存在不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            SchisandraOssPinganBO schisandraOssPinganBO = SchisandraOssPinganDTOConverter.INSTANCE.convertDTOToBO(schisandraOssPinganDTO);
            return Result.ok(schisandraOssPinganDomainService.update(schisandraOssPinganBO));
        } catch (Exception e) {
            log.error("SchisandraOssPinganController.update.error:{}", e.getMessage(), e);
            return Result.fail("更新平安云对象存储配置表信息失败");
        }

    }

    /**
     * 删除平安云对象存储配置表
     */
    @RequestMapping("delete")
    public Result<Boolean> delete(@RequestBody SchisandraOssPinganDTO schisandraOssPinganDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssPinganController.delete.dto:{}", JSON.toJSONString(schisandraOssPinganDTO));
            }
            Preconditions.checkNotNull(schisandraOssPinganDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getSystemUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getUserAgent(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getObsUrl(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getObsAccessKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getObsSecret(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getBucketName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getRepresentPathInKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getDomainName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getExtraJson(), "额外字段不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getCreateBucket(), "当桶不存在，是否创建不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getCheckBucket(), "启动检测桶，是否存在不能为空");
            Preconditions.checkNotNull(schisandraOssPinganDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            SchisandraOssPinganBO schisandraOssPinganBO = SchisandraOssPinganDTOConverter.INSTANCE.convertDTOToBO(schisandraOssPinganDTO);
            return Result.ok(schisandraOssPinganDomainService.delete(schisandraOssPinganBO));
        } catch (Exception e) {
            log.error("SchisandraOssPinganController.delete.error:{}", e.getMessage(), e);
            return Result.fail("删除平安云对象存储配置表信息失败");
        }

    }

}
